var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "te-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty('entries/' + path, value);
        Property.setFlag('entries/' + path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function updateData() {
    Property.load();
    var baseNodes = Property.getNode('events');
    lInfo.logln("UpdateDataStart");
    if (baseNodes == null) {
        lInfo.logln("nothing to Update");
        return;
    }    
    var fError=false;
    var fAnythingDone=false;
    var oBaseArray=baseNodes.getChildren();
    for ( var iIndex = 0; iIndex < oBaseArray.length; iIndex++) {
        fAnythingDone=true;
        lInfo.logln("found #" + iIndex);
        var oNewID=getNewIdValue();
        lInfo.logln("using id " + oNewID);
        try 
        {
            var oTriggerNode=oBaseArray[iIndex];
            var sName=oTriggerNode.getChild('name').getValue();         
            lInfo.logln("Name: " + sName);
            var fDisabled=oTriggerNode.getChild('disabled').getValue();
            lInfo.logln("fDisabled: " + fDisabled);
            storeSubParameter(oNewID + '/name', sName);            
            storeSubParameter(oNewID + '/id', oNewID);
            
            if (fDisabled)
                storeSubParameter(oNewID + '/conditions/enabled', false);
            else
                storeSubParameter(oNewID + '/conditions/enabled', true);
            
            var oActionNodes=oTriggerNode.getChild('actions').getChildren();
            for (var jIndex=0;jIndex<oActionNodes.length;jIndex++) {
                var oActionNode=oActionNodes[jIndex];
                if (oActionNode.getChild('device')!=null) {
                    //device calls
                    if (oActionNode.getChild('blink')!=null) {
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('device').getValue() + " blink");
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'device-blink');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/dsid', oActionNode.getChild('device').getValue());
                    } else if (oActionNode.getChild('outputValue')!=null) {
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('device').getValue() + " outvalue " + oActionNode.getChild('outputValue').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'device-value');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/dsid', oActionNode.getChild('device').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/value', oActionNode.getChild('outputValue').getValue());
                    } else if (oActionNode.getChild('scene')!=null){
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('device').getValue() + " scene " +oActionNode.getChild('scene').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'device-scene');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/dsid', oActionNode.getChild('device').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/scene', oActionNode.getChild('scene').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/force', false);
                    }
                } else {
                    // zone calls
                    if (oActionNode.getChild('blink')!=null) {
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('zone').getValue() + " " + oActionNode.getChild('group').getValue() + " blink");
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'zone-blink');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/zone', oActionNode.getChild('zone').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/group', oActionNode.getChild('group').getValue());
                    } else if (oActionNode.getChild('outputValue')!=null) {
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('zone').getValue() + " " + oActionNode.getChild('group').getValue() + " outvalue " + oActionNode.getChild('outputValue').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'zone-value');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/zone', oActionNode.getChild('zone').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/group', oActionNode.getChild('group').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/value', oActionNode.getChild('outputValue').getValue());
                    } else if (oActionNode.getChild('scene')!=null){
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('zone').getValue() + " " + oActionNode.getChild('group').getValue() +  " scene " +oActionNode.getChild('scene').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'zone-scene');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/zone', oActionNode.getChild('zone').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/group', oActionNode.getChild('group').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/scene', oActionNode.getChild('scene').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/force', false);
                    }                    
                }
            }            
          
            if (oTriggerNode.getChild('recurring').getValue()) {
                // wiederholung
              //time : timebase: 'absolute', 'daily', 'sunrise', 'sunset' | offset: seconds
                storeSubParameter(oNewID + '/time/recurrenceBase', 'weekly');
                if (oTriggerNode.getChild('weekdays')!=null) {
                    var sText=oTriggerNode.getChild('weekdays').getValue();
                    var oArray=sText.split(',');
                    for (var kIndex=0;kIndex<oArray.length;kIndex++) {
                        if (oArray[kIndex]=='0')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'SU');
                        if (oArray[kIndex]=='1')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'MO');
                        if (oArray[kIndex]=='2')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'TU');
                        if (oArray[kIndex]=='3')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'WE');
                        if (oArray[kIndex]=='4')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'TH');
                        if (oArray[kIndex]=='5')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'FR');
                        if (oArray[kIndex]=='6')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'SA');
                    }
                } else if (oTriggerNode.getChild('recurrence')!=null) {
                    for (var kIndex=0;kIndex<oTriggerNode.getChild('recurrence').getChildren().length;kIndex++) {
                        storeSubParameter(oNewID + '/time/recurrence/' + kIndex, oTriggerNode.getChild('recurrence').getChildren()[kIndex].getValue());
                    }
                }
                
                
            } else {
                // einzelnes
                storeSubParameter(oNewID + '/time/recurrenceBase', 'absolute');
                storeSubParameter(oNewID + '/time/date/0', oTriggerNode.getChild('recurrence/0').getValue()); // 2012-02-07
              //time : timebase: 'absolute', 'daily', 'sunrise', 'sunset' | offset: seconds
            }
            var sTime=oTriggerNode.getChild('time').getValue();
            if (sTime.indexOf('sunrise')!=-1)
            {
                storeSubParameter(oNewID + '/time/timeBase', 'sunrise');
                sTime=sTime.substring(7);
                var oArray=sTime.split(':');
                var oTimeDiv=Math.abs(parseInt(oArray[2],10));
                oTimeDiv+=Math.abs(parseInt(oArray[1],10))*60;
                oTimeDiv+=Math.abs(parseInt(oArray[0],10))*60*60;
                if (oTimeDiv!=0)
                    if (oArray[0].indexOf('-')==0)
                        oTimeDiv*=-1;
                storeSubParameter(oNewID + '/time/offset', oTimeDiv);
            } else if (sTime.indexOf('sunset')!=-1)
            {
                storeSubParameter(oNewID + '/time/timeBase', 'sunset');
                sTime=sTime.substring(6);
                var oArray=sTime.split(':');
                var oTimeDiv=Math.abs(parseInt(oArray[2],10));
                oTimeDiv+=Math.abs(parseInt(oArray[1],10))*60;
                oTimeDiv+=Math.abs(parseInt(oArray[0],10))*60*60;
                if (oTimeDiv!=0)
                    if (oArray[0].indexOf('-')==0)
                        oTimeDiv*=-1;
                storeSubParameter(oNewID + '/time/offset', oTimeDiv);
            } else {
                storeSubParameter(oNewID + '/time/timeBase', 'daily');
                var oArray=sTime.split(':');
                var oTimeDiv=Math.abs(parseInt(oArray[2],10));
                oTimeDiv+=Math.abs(parseInt(oArray[1],10))*60;
                oTimeDiv+=Math.abs(parseInt(oArray[0],10))*60*60;
                if (oTimeDiv!=0)
                    if (oArray[0].indexOf('-')==0)
                        oTimeDiv*=-1;
                storeSubParameter(oNewID + '/time/offset', oTimeDiv);
            }
            
            
            lInfo.logln("done. Delete old Node " + oTriggerNode.getPath());
            baseNodes.removeChild(oTriggerNode);
        }
        catch (e)
        {
            lWarn.logln("Fehler beim Datenupgrade " + e);
            if (Property.getNode('entries')!=null)
                Property.getNode('entries').removeChild(oNewID);
            fError=true;
        }        
    }
    if (!fError) {
        lInfo.logln("All done. Delete old Node");
        Property.getNode('/scripts/system-addon-timed-events').removeChild('events');
    }
    Property.store();
}

updateData();